#!/usr/bin/python3
# -*- coding: utf-8; -*-
#
# (c) 2007-2008 Mandriva, http://www.mandriva.com/
#
# $Id$
#
# This file is part of Pulse 2, http://pulse2.mandriva.org
#
# Pulse 2 is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Pulse 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Pulse 2; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

"""
    Pulse2 Modules
"""

import hashlib
import sys


def sumfile(fobj):
    """Returns an md5 hash for an object with read() method."""
    m = hashlib.new("md5")
    while True:
        d = fobj.read(8096)
        if not d:
            break
        m.update(d)
    return m.hexdigest()


def md5file(fname):
    """Returns an md5 hash for file fname, or stdin if fname is "-"."""
    if fname == "-":
        ret = sumfile(sys.stdin)
    else:
        try:
            f = open(fname, "rb")
        except BaseException:
            return "Failed to open file"
        ret = sumfile(f)
        f.close()
    return ret


def md5sum(str):
    return hashlib.md5(str).hexdigest()
